#pragma once
#ifndef CERES_H
#define CERES_H

#include "ceres/ceres.h"
#include "glog/logging.h"

using ceres::AutoDiffCostFunction;
using ceres::CostFunction;
using ceres::Problem;
using ceres::Solver;
using ceres::Solve;

// A templated cost functor that implements the residual r = 10 - x.
// The method operator() is templated so that we can then use an automatic differentiation wrapper around it to generate its derivatives.
struct CostFunctor {
	template <typename T> bool operator()(const T* const x, T* residual) const {
		residual[0] = 10.0 - x[0];
		return true;
	}
};

#endif